/// <reference types="node" />
import { APIGatewayProxyEventV2, APIGatewayProxyStructuredResultV2, Context } from 'aws-lambda';
import { Server, IncomingHttpHeaders, OutgoingHttpHeaders } from 'http';
export interface NowProxyRequest {
    method: string;
    path: string;
    headers: IncomingHttpHeaders;
    body: Buffer;
}
export interface NowProxyResponse {
    statusCode: number;
    headers: OutgoingHttpHeaders;
    body: string;
    isBase64Encoded: boolean;
}
interface ServerLike {
    timeout?: number;
    listen: (opts: {
        host?: string;
        port?: number;
    }, callback: (this: Server | null) => void) => Server | void;
}
export declare class Bridge {
    private server;
    private listening;
    private resolveListening;
    private events;
    private reqIdSeed;
    private shouldStoreEvents;
    constructor(server?: ServerLike, shouldStoreEvents?: boolean);
    setServer(server: ServerLike): void;
    listen(): void | Server;
    launcher(event: APIGatewayProxyEventV2, context: Pick<Context, 'callbackWaitsForEmptyEventLoop'>): Promise<APIGatewayProxyStructuredResultV2>;
    consumeEvent(reqId: string): NowProxyRequest;
}
export {};
